"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var common = require('./image-cache-it.common');
var utils = require("utils/utils");
var imageSrc = require("image-source");
var style = require("ui/styling/style");
var background = require("ui/styling/background");
var Request = com.squareup.picasso.Request;
var ImageCacheIt = (function (_super) {
    __extends(ImageCacheIt, _super);
    function ImageCacheIt() {
        _super.call(this);
    }
    Object.defineProperty(ImageCacheIt.prototype, "android", {
        get: function () {
            return this._android;
        },
        enumerable: true,
        configurable: true
    });
    ImageCacheIt.prototype._createUI = function () {
        this._android = new android.widget.ImageView(this._context);
        if (!this.imageUri) {
            return;
        }
        this._setNativeImage(this.imageUri);
    };
    ImageCacheIt.prototype._setNativeImage = function (nativeImage) {
        this.picasso = new com.squareup.picasso.Picasso.with(this._context).load(nativeImage);
        if (this.placeHolder) {
            var ph = this.getImage(this.placeHolder);
            this.picasso.placeholder(ph);
        }
        if (this.errorHolder) {
            var eh = this.getImage(this.errorHolder);
            this.picasso.error(eh);
        }
        if (this.resize && this.resize !== undefined && this.resize.split(',').length > 1) {
            this.picasso.resize(parseInt(this.resize.split(',')[0]), parseInt(this.resize.split(',')[1]));
        }
        if (this.centerCrop) {
            this.picasso.centerCrop();
        }
        this.picasso.into(this._android);
    };
    ImageCacheIt.prototype.getImage = function (image) {
        switch (typeof image) {
            case 'string':
                if (image.indexOf('res://') > -1) {
                    var src = imageSrc.fromResource(image);
                    var res = utils.ad.getApplicationContext().getResources();
                    return new android.graphics.drawable.BitmapDrawable(res, src.android);
                }
                else if (image.substr(0, 2) === '~/') {
                    var src = imageSrc.fromFile(image);
                    var res = utils.ad.getApplicationContext().getResources();
                    return new android.graphics.drawable.BitmapDrawable(res, src.android);
                }
        }
    };
    return ImageCacheIt;
}(common.ImageCacheIt));
exports.ImageCacheIt = ImageCacheIt;
var ImageStyler = (function () {
    function ImageStyler() {
    }
    ImageStyler.setBorderRadiusProperty = function (v, newValue, defaultValue) {
        if (!v._nativeView) {
            return;
        }
        var val = Math.round(newValue * utils.layout.getDisplayDensity());
        v._nativeView.setCornerRadius(val);
        background.ad.onBackgroundOrBorderPropertyChanged(v);
    };
    ImageStyler.resetBorderRadiusProperty = function (v, nativeValue) {
        if (!v._nativeView) {
            return;
        }
        v._nativeView.setCornerRadius(0);
        background.ad.onBackgroundOrBorderPropertyChanged(v);
    };
    ImageStyler.setBorderWidthProperty = function (v, newValue, defaultValue) {
        if (!v._nativeView) {
            return;
        }
        var val = Math.round(newValue * utils.layout.getDisplayDensity());
        v._nativeView.setBorderWidth(val);
        background.ad.onBackgroundOrBorderPropertyChanged(v);
    };
    ImageStyler.resetBorderWidthProperty = function (v, nativeValue) {
        if (!v._nativeView) {
            return;
        }
        v._nativeView.setBorderWidth(0);
        background.ad.onBackgroundOrBorderPropertyChanged(v);
    };
    ImageStyler.registerHandlers = function () {
        style.registerHandler(style.borderRadiusProperty, new style.StylePropertyChangedHandler(ImageStyler.setBorderRadiusProperty, ImageStyler.resetBorderRadiusProperty), "ImageCacheIt");
        style.registerHandler(style.borderWidthProperty, new style.StylePropertyChangedHandler(ImageStyler.setBorderWidthProperty, ImageStyler.resetBorderWidthProperty), "ImageCacheIt");
    };
    return ImageStyler;
}());
exports.ImageStyler = ImageStyler;
ImageStyler.registerHandlers();
//# sourceMappingURL=image-cache-it.android.js.map